<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: headers/playerperspective.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7f57b1e41c5acd0e859ae5f3a2b075a9.html">headers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">playerperspective.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef PLAYERPERSPECTIVE_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define PLAYERPERSPECTIVE_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;game.h&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;qgraphicsscene.h&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;table.h&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;dialoguebox.h&gt;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno"><a class="line" href="classPlayerPerspective.html">   10</a></span>&#160;<span class="keyword">class </span><a class="code" href="classPlayerPerspective.html">PlayerPerspective</a>:<span class="keyword">public</span> QGraphicsScene</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;{</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    Q_OBJECT</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <a class="code" href="classPlayerPerspective.html">PlayerPerspective</a>(<a class="code" href="classGame.html">Game</a>*game,<span class="keywordtype">int</span> playerIndex,QObject*parent=<span class="keyword">nullptr</span>);</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <a class="code" href="classPlayerPerspective.html">PlayerPerspective</a>();</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="keywordtype">void</span> addGameToScene();</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keywordtype">void</span> removeGameFromScene();</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keywordtype">void</span> drawCards(<span class="keywordtype">int</span> n);</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keywordtype">void</span> setNextPlayerToToMove();</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keywordtype">int</span> getPlayerToMoveIndex()<span class="keyword">const</span>;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keywordtype">int</span> getPlayerSize();</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">public</span> slots:</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="comment">// Reacting to internal signals</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keywordtype">void</span> onClickedTreasureInWagonInTrain(<a class="code" href="classTreasure.html">Treasure</a>*t,<a class="code" href="classWagon.html">Wagon</a>*w,<a class="code" href="classTrain.html">Train</a>*train);</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordtype">void</span> onClickedCardInHandInPlayer(<a class="code" href="classCard.html">Card</a>*c,<a class="code" href="classHand.html">Hand</a>*h,<a class="code" href="classPlayer.html">Player</a>*p);<span class="comment">//*</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordtype">void</span> onClickedCardInDeckInPlayer(<a class="code" href="classCard.html">Card</a>*c,<a class="code" href="classDeck.html">Deck</a>*d,<a class="code" href="classPlayer.html">Player</a>*p);</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">void</span> onClickedTreasureInPlayerStatsInTable(<a class="code" href="classTreasure.html">Treasure</a>*,<a class="code" href="classPlayerStats.html">PlayerStats</a>*,<a class="code" href="classTable.html">Table</a>*);</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keywordtype">void</span> onClickedPlayerInWagonInTrain(<a class="code" href="classPlayer.html">Player</a>*,<a class="code" href="classWagon.html">Wagon</a>*,<a class="code" href="classTrain.html">Train</a>*);</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">void</span> onClickedWagonInTrain(<a class="code" href="classWagon.html">Wagon</a>*w,<a class="code" href="classTrain.html">Train</a>*train);<span class="comment">//*</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="comment">// Reacting to external signals</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">void</span> onPlayerChoseWagon(<span class="keywordtype">int</span> playerIndex,<span class="keywordtype">int</span> wagonIndex);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">void</span> onPlayerPlayedCard(<span class="keywordtype">int</span> playerIndex,<span class="keywordtype">int</span> CardIndex);</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">void</span> onPlayerDrawCards(<span class="keywordtype">int</span> playerIndex);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keywordtype">void</span> onActionSheriffSignal (<span class="keywordtype">int</span> wagonIndex);</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keywordtype">void</span> onActionFireSignal(<span class="keywordtype">int</span> playerIndex);</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordtype">void</span> onActionChangeFloorSignal(<span class="keywordtype">int</span> wagonIndex);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keywordtype">void</span> onActionChangeWagonSignal(<span class="keywordtype">int</span> wagonIndex);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keywordtype">void</span> onActionRobberySignal(<span class="keywordtype">int</span> treasureIndex, <span class="keywordtype">int</span> wagonIndex);</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordtype">void</span> onActionPunchSignal(<span class="keywordtype">int</span> treasureIndex, <span class="keywordtype">int</span> playerIndex, <span class="keywordtype">int</span> wagonIndex);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;signals:</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">void</span> playerChoseWagon(<span class="keywordtype">int</span> playerIndex,<span class="keywordtype">int</span> wagonIndex);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">void</span> playerPlayedCard(<span class="keywordtype">int</span> playerIndex,<span class="keywordtype">int</span> CardIndex);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">void</span> movePlayed(<a class="code" href="classPlayerPerspective.html">PlayerPerspective</a>*, <span class="keywordtype">int</span> indexOfNextPerspective);</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">void</span> playerDrawCards(<span class="keywordtype">int</span> playerIndex);</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">void</span> actionSheriffSignal (<span class="keywordtype">int</span> wagonIndex);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">void</span> actionFireSignal(<span class="keywordtype">int</span> playerIndex);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">void</span> actionChangeFloorSignal(<span class="keywordtype">int</span> wagonIndex);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keywordtype">void</span> actionChangeWagonSignal(<span class="keywordtype">int</span> wagonIndex);</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordtype">void</span> actionRobberySignal(<span class="keywordtype">int</span> treasureIndex, <span class="keywordtype">int</span> wagonIndex);</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keywordtype">void</span> actionPunchSignal(<span class="keywordtype">int</span> treasureIndex, <span class="keywordtype">int</span> playerIndex, <span class="keywordtype">int</span> wagonIndex);</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordtype">void</span> setMyMove(<span class="keywordtype">bool</span>);</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <a class="code" href="classPlayer.html">Player</a>*m_player;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <a class="code" href="classGame.html">Game</a>*m_game;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <a class="code" href="classTable.html">Table</a>*m_table;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;};</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="preprocessor">#endif </span><span class="comment">// PLAYERPERSPECTIVE_H</span></div>
<div class="ttc" id="aclassCard_html"><div class="ttname"><a href="classCard.html">Card</a></div><div class="ttdef"><b>Definition:</b> card.h:15</div></div>
<div class="ttc" id="aclassDeck_html"><div class="ttname"><a href="classDeck.html">Deck</a></div><div class="ttdef"><b>Definition:</b> deck.h:11</div></div>
<div class="ttc" id="aclassGame_html"><div class="ttname"><a href="classGame.html">Game</a></div><div class="ttdef"><b>Definition:</b> game.h:31</div></div>
<div class="ttc" id="aclassHand_html"><div class="ttname"><a href="classHand.html">Hand</a></div><div class="ttdef"><b>Definition:</b> hand.h:9</div></div>
<div class="ttc" id="aclassPlayerPerspective_html"><div class="ttname"><a href="classPlayerPerspective.html">PlayerPerspective</a></div><div class="ttdef"><b>Definition:</b> playerperspective.h:11</div></div>
<div class="ttc" id="aclassPlayerStats_html"><div class="ttname"><a href="classPlayerStats.html">PlayerStats</a></div><div class="ttdef"><b>Definition:</b> playerstats.h:9</div></div>
<div class="ttc" id="aclassPlayer_html"><div class="ttname"><a href="classPlayer.html">Player</a></div><div class="ttdef"><b>Definition:</b> player.h:22</div></div>
<div class="ttc" id="aclassTable_html"><div class="ttname"><a href="classTable.html">Table</a></div><div class="ttdef"><b>Definition:</b> table.h:12</div></div>
<div class="ttc" id="aclassTrain_html"><div class="ttname"><a href="classTrain.html">Train</a></div><div class="ttdef"><b>Definition:</b> train.h:10</div></div>
<div class="ttc" id="aclassTreasure_html"><div class="ttname"><a href="classTreasure.html">Treasure</a></div><div class="ttdef"><b>Definition:</b> treasure.h:16</div></div>
<div class="ttc" id="aclassWagon_html"><div class="ttname"><a href="classWagon.html">Wagon</a></div><div class="ttdef"><b>Definition:</b> wagon.h:12</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
